import scala.tools.nsc._
import scala.tools.nsc.io.VirtualDirectory
import scala.tools.nsc.reporters._
import scala.tools.nsc.interpreter.AbstractFileClassLoader

class InMemoryInterpreter(override val settings: Settings,
						  parentClassLoader : ClassLoader) 
											extends Interpreter(settings) {
 
  override def classLoader = 
	new AbstractFileClassLoader(virtualDirectory, parentClassLoader)
	
  override protected def newCompiler(settings: Settings, 
									 reporter: Reporter) = {
	settings.outputDirs.setSingleOutput(virtualDirectory)

    val comp = new scala.tools.nsc.Global(settings, reporter)
    comp
  }
}