import scala.tools.nsc.*;
import java.io.File;
import java.net.*;

class ScalaBootLoader {
	public void compile(String args[]) {
		interpreter.reset();
		interpreter.compileString(args[0]);

		try {
			payoff = (Payoff) interpreter.classLoader().
				loadClass("PayoffImpl").newInstance();
		} catch (Exception e) { e.printStackTrace(); }
	}

	public double[] payoff(double a[]) {
		return payoff.payoff(a);
	}

	public void shutdown() {
		interpreter.close();
	}

	private Payoff payoff;
	private static InMemoryInterpreter interpreter = 
		new InMemoryInterpreter(new Settings(), 
								Thread.currentThread().
								getContextClassLoader());
}
