/* -*- mode: c++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*
 Copyright (C) 2011 Klaus Spanderen

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.
*/

#ifndef sandbox_hpp
#define sandbox_hpp

#include <ql/types.hpp>
#include <ql/patterns/singleton.hpp>
#include <ql/utilities/disposable.hpp>

#include <jni.h>
#include <string>
#include <vector>

using namespace QuantLib;

class Sandbox : public Singleton<Sandbox> {
  public:
    ~Sandbox();

    void compile(const std::string& fileName) const;
    const Disposable<std::vector<Real> > 
    payoff(const std::vector<Real>& path) const;

  protected:
    Sandbox();

  private:
    friend class Singleton<Sandbox>;

    JavaVM *jvm_;
    JNIEnv *env_;
    jobject scalaBootLoader_;
    jclass scalaBootLoaderClass_, stringClass_;
    jmethodID compileMethodID_, payoffMethodID_;  
};

#endif
